#!/bin/sh
#
# $Header: /CVSROOT/public/scylla-charybdis/md5backup/bin/sc-setup.sh,v 1.1 2004/09/29 00:02:35 tino Exp $
#
# Just run it after bin/dobackup.sh
# It does the rest of the setup for you.
#
# $Log: sc-setup.sh,v $
# Revision 1.1  2004/09/29 00:02:35  tino
# added
#

if [ -z "$TINO_DEVEL" ]; then echo "This script is not ready yet!"; exit; fi

MD5B="/backup/md5backup"
HERE="/backup/charybdis"

DIRS="$HERE $MD5B/ln1 $HERE/tmp $HERE/md5move $HERE/md5move/log $HERE/md5move/,d5 $HERE/md5move/mysql"
BINS="charybdis"
COPY="sc-move.sh sc-mysql.sh sc-backup.sh sc-loop.sh"
CONF="sc-move.conf"

if [ .root != ".`id -un`" ]
then
	echo "$0 must be called as root.  SU to root and try again." >&2
	exit 1
fi

presskey()
{
echo -n "Press return to continue, ^D to abort -> "
read || exit 1
echo
}

pressy()
{
echo -n "$* (y/N)? "
read || exit 1
[ .y = ".$REPLY" ] || exit 1
}

isme()
{
cmp -s "$0" "$1"
}

echo "This does the setup of networking part of md5backup."
echo ""
echo "Note that this part is a quick hack and will be"
echo "considered obsolete in (some far) future, when the"
echo "networking option of md5backup (or the successor of"
echo "it will evolve.  However for now it's all there is."
echo ""

if [ ! -d "$MD5D" ]
then
	echo "The directory $MD5D"
	echo "does not exist.  This means, you have never run"
	echo ""
	echo "bin/dobackup.sh"
	echo ""
	echo "This script assumes that you have run this first!"
	echo "Please do it now and then run this here again."
	exit 1
fi

setup_dirs()
{
echo "setup_dirs"
exit
}

setup_bins()
{
echo "setup_bins"
exit
}

setup_copy()
{
echo "setup_copy"
exit
}

for a in $DIRS
do
	if [ ! -d "$a" ]
	then
		echo "missing dir $a"
		setup_dirs >&2
		break
	fi
done

for a in $BINS
do
	if [ ! -x "bin/$a" ]
	then
		echo "missing bin/$a"
		setup_bins >&2
		break
	fi
done

for a in $COPY
do
	if [ ! -x "$HERE/$a" ]
	then
		echo "missing $HERE/$a"
		setup_copy >&2
		break
	fi
done

# CONF
